require 'mnam/connection'
require 'mnam/configurable'
require 'mnam/transaction_builder'

require 'mnam/client/account'
require 'mnam/client/block'
require 'mnam/client/delegate'
require 'mnam/client/loader'
require 'mnam/client/multisignature'
require 'mnam/client/peer'
require 'mnam/client/signature'
require 'mnam/client/transaction'

module Mnam
  MAIN_NETWORK_ADDRESS = '17'
  DEV_NETWORK_ADDRESS = '1e'

  class Client
    include Mnam::Configurable
    include Mnam::Connection
    include Mnam::Client::Account
    include Mnam::Client::Block
    include Mnam::Client::Delegate
    include Mnam::Client::Loader
    include Mnam::Client::MultiSignature
    include Mnam::Client::Peer
    include Mnam::Client::Signature
    include Mnam::Client::Transaction

    def initialize(options = {})
      Mnam::Configurable.keys.each do |key|
        instance_variable_set(:"@#{key}", options[key] || Mnam.instance_variable_get(:"@#{key}"))
      end

      @network_address ||= Mnam::MAIN_NETWORK_ADDRESS
    end
  end
end
